<template>
  <div>
    <md-dialog :md-active.sync="showDialog">
      <md-dialog-title>{{ product.name }}, {{ product.price.formatted }}</md-dialog-title>
      <md-dialog-content>
        <p>Please enter quantity and money you have.</p>
        <md-field>
          <label>Enter quantity</label>
          <md-input
              type="number"
              id="purchaseQuantity"
              name="purchaseQuantity"
              v-model="purchaseQuantity"
              :disabled="isLoading"
              min="1"
              :max="quantity"
          />
        </md-field>
        <md-field>
          <label>Insert money</label>
          <md-select v-model="money" name="money">
            <md-option
                v-for="money in acceptedMoney"
                :value="money.value"
                :key="money.formatted"
            >{{ money.formatted }}</md-option>
          </md-select>
        </md-field>
      </md-dialog-content>

      <md-dialog-actions>
        <md-button class="md-primary" @click="showDialog = false">Cancel</md-button>
        <md-button class="md-primary" @click="confirm" :disabled="isLoading">Confirm</md-button>
      </md-dialog-actions>
    </md-dialog>

    <md-dialog-alert
        :md-active.sync="showError"
        md-title="Purchase Error!"
        :md-content="error"
        @update:md-active="showError = false"
    />

    <md-dialog :md-active.sync="showPurchase" >
      <md-dialog-title>Your Purchase</md-dialog-title>
      <md-dialog-content>
        <table v-if="purchase" style="width: 100%;">
          <tbody>
          <tr>
            <td>Item</td>
            <td>{{ purchase.product.name }} <br>{{ purchase.product.price.formatted }}</td>
          </tr>
          <tr>
            <td>Your change</td>
            <td>
              <div v-for="change in purchase.change.change" :key="change.money.type+change.money.formatted">
                {{ change.money.formatted }} x {{ change.quantity }}
                {{ change.money.type }}<template v-if="change.quantity > 1">s</template>
              </div>

              <div v-if="purchase.left_amount > 0">
                We could not return you {{ purchase.left_amount }} due to technical reasons.
              </div>
            </td>
          </tr>
          </tbody>
        </table>
        <div style="margin: 10px 0">Thank you for your purchase!</div>
      </md-dialog-content>

      <md-dialog-actions>
        <md-button class="md-primary" @click="showPurchase = false">Close</md-button>
      </md-dialog-actions>
    </md-dialog>

    <md-button class="md-primary md-raised" @click="showDialog = true">Purchase</md-button>
  </div>
</template>

<script>

import API from '@/api';

export default {
  name: 'VendingMachinePurchase',
  props: {
    slotIndex: {
      type: String,
      required: true,
    },
    quantity: {
      type: Number,
      default: 0,
      required: true,
    },
    product: {
      type: Object,
      required: true,
    },
    acceptedMoney: {
      type: Array,
      default() {
        return [];
      },
    }
  },
  data() {
    return {
      showDialog: false,
      isLoading: false,
      purchaseQuantity: 1,
      money: 50,
      error: null,
      showError: false,
      showPurchase: false,
      purchase: null,
    };
  },
  methods: {
    async confirm() {
      if (this.isLoading) {
        return;
      }

      this.isLoading = true;

      try {
        this.purchase = (await API.purchase(
            this.slotIndex,
            this.purchaseQuantity,
            this.money,
        )).data.purchase;
        this.showPurchase = true;
        this.showDialog = false;
        this.$emit('machine:purchased', this.purchase);
      } catch (e) {
        this.error = e.response.data.message;
        this.showError = true;
      } finally {
        this.isLoading = false;
      }
    },
  },
};
</script>

<style scoped>
table {
  border-collapse: collapse;
  width: 50%;
}

table td {
  padding: 5px 10px;
  border: 1px solid;
  text-align: left;
}

</style>
